require "import"
import "android.content.Intent"
import "android.net.Uri"
import "android.widget.*"
import "android.view.View"
import "android.content.Context"
import "android.os.Vibrator"
import "android.view.KeyEvent"

local context = activity or service
local dlg

local function openTelegram(url)
    local intent = Intent(Intent.ACTION_VIEW)
    intent.setData(Uri.parse(url))
    intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK)
    context.startActivity(intent)
end

local function vibrateDevice(duration)
    local vibrator = context.getSystemService(Context.VIBRATOR_SERVICE)
    if vibrator.hasVibrator() then
        vibrator.vibrate(duration)
    end
end

local layout = {
    LinearLayout,
    orientation = LinearLayout.VERTICAL,
    padding = "16dp",
    {
        TextView,
        text = "Chatbots de Inteligencia Artificial de Telegram",
        textSize = "18sp",
        gravity = "center",
        layout_width = "match_parent",
        layout_height = "wrap_content",
    },
    {
        Button,
        text = "Copilot",
        onClick = function(v)
            vibrateDevice(200)
            openTelegram("https://t.me/CopilotOfficialBot")
            dlg.dismiss()
        end,
        layout_width = "match_parent",
        layout_height = "wrap_content",
    },
    {
        Button,
        text = "MS Speech Bot",
        onClick = function(v)
            vibrateDevice(200)
            openTelegram("https://t.me/msspeechbot")
            dlg.dismiss()
        end,
        layout_width = "match_parent",
        layout_height = "wrap_content",
    },
    {
        Button,
        text = "New File Converter Bot",
        onClick = function(v)
            vibrateDevice(200)
            openTelegram("https://t.me/newfileconverterbot")
            dlg.dismiss()
        end,
        layout_width = "match_parent",
        layout_height = "wrap_content",
    },
    {
        Button,
        text = "YouMusic Bot",
        onClick = function(v)
            vibrateDevice(200)
            openTelegram("https://t.me/YouMusicRobot")
            dlg.dismiss()
        end,
        layout_width = "match_parent",
        layout_height = "wrap_content",
    },
    {
        EditText,
        id = "customUrlEditText",
        hint = "Ingresa un enlace de Telegram",
        layout_width = "match_parent",
        layout_height = "wrap_content",
    },
    {
        Button,
        text = "Abrir Telegram con enlace personalizado",
        onClick = function(v)
            vibrateDevice(200)
            local customUrl = customUrlEditText.getText().toString()
            if customUrl ~= "" then
                openTelegram(customUrl)
            else
                Toast.makeText(context, "Por favor ingresa un enlace", Toast.LENGTH_SHORT).show()
            end
        end,
        layout_width = "match_parent",
        layout_height = "wrap_content",
    },
    {
        Button,
        text = "Cerrar",
        onClick = function(v)
            vibrateDevice(200)
            dlg.dismiss()
        end,
        layout_width = "wrap_content",
        layout_height = "wrap_content",
        layout_gravity = "center_horizontal",
    },
}

dlg = LuaDialog(context)
dlg.setTitle("Chatbots de Inteligencia Artificial de Telegram")
dlg.setView(loadlayout(layout))
dlg.show()

function onKeyDown(code, event)
    if code == KeyEvent.KEYCODE_BACK then
        vibrateDevice(200)
        dlg.dismiss()
        return true
    end
end